package de.hdm_stuttgart.mi.sd1.task1;

/**
 * Scrabble game scores.
 * 
 * <object data="doc-files/scrabble.jpg" type="image/jpg" ></object>
 *
 */
public class _5_Scrabble {
    /**
     * <p>Compute the Scrabble score of a given word.</p>
     *
     * <p>The Scrabble game awards scores for words using the usual the A-Z alphabet. Each character receives a case
     * independent score:</p>
     *
     *    <table class="goikTableDefaults">
     *        <tr>
     *            <th>Letters</th>
     *            <th>Score</th>
     *        </tr>
     *        <tr>
     *            <td>A, E, I, O, U, L, N, R, S, T</td>
     *            <td>1</td>
     *        </tr>
     *        <tr>
     *            <td>D, G</td>
     *            <td>2</td>
     *        </tr>
     *        <tr>
     *            <td>B, C, M, P</td>
     *            <td>3</td>
     *        </tr>
     *        <tr>
     *            <td>F, H, V, W, Y</td>
     *            <td>4</td>
     *        </tr>
     *        <tr>
     *            <td>K</td>
     *            <td>5</td>
     *        </tr>
     *        <tr>
     *            <td>J, X</td>
     *            <td>8</td>
     *        </tr>
     *        <tr>
     *            <td>Q, Z</td>
     *            <td>10</td>
     *        </tr>
     *    </table>
     *
     *  <p>A word's score equals the sum of its character scores. We calculate the score of
     *  <code>"CYPHERTEXT"</code> :</p>
     *
     * <object data="doc-files/scrabble.svg" type="image/svg+xml"></object>
     *
     * @param word A string or null
     * @return The word's score. Zero for empty string or <code>null</code>.
     */
    static public int getScore(final String word) {
        if (null == word) {
            return 0;
        } else {
            int score = 0;
            for (final char c: word.toUpperCase().toCharArray()) {
                score += getLetterScore(c);
            }
            return score;
        }
    }

    static private byte getLetterScore(final char c) {
        switch(c) {
            case 'A':
            case 'E':
            case 'I':
            case 'O':
            case 'U':
            case 'L':
            case 'N':
            case 'R':
            case 'S':
            case 'T':
                return 1;

            case 'D':
            case 'G':
                return 2;

            case 'B':
            case 'C':
            case 'M':
            case 'P':
                return 3;

            case 'F':
            case 'H':
            case 'V':
            case 'W':
            case 'Y':
                return 4;

            case 'K':
                return 5;

            case 'J':
            case 'X':
                return 8;

            case 'Q':
            case 'Z':
                return 10;
        }
        return 0;
    }

    private _5_Scrabble(){/* Ignore me: My presence suppresses an otherwise visible default constructor's Javadoc */}
}
