package de.hdm_stuttgart.mi.sd1.task1;

import java.util.Arrays;

/**
 * Providing a single helper method.
 */
public class _4_ArrayHelper {

    /**
     * Eliminate all array values being equal to a given one. The resulting array may be shorter than the original one.
     * Examples:
     *
     * <ul>
     *     <li><code>input = {<span style="color:red;">1</span>, 2, 3, <span style="color:red;">1</span>}</code>,
     *     <code>excludedValue = <span style="color:red;">1</span></code> yields <code>{2, 3}</code></li>
     *
     *     <li><code>input = {5, 4, 3, 5}, excludedValue = <span style="color:red;">0</span></code> yields the unchanged
     *     original values <code>{5, 4, 3, 5}</code></li>
     *
     * </ul>
     *
     * @param input An array or <code>null</code> the latter being treated as an empty array.
     * @param excludedValue This value will be eliminated from the input array.
     * @return A <b>new</b> array containing only those original array's  values being different from <code>excludedValue</code>.
     *
     * <section class="implementationHints">
     *    <h3 class="implementationHints">Implementation idea:</h3>
     *    <ol>
     *        <li>Create a new array of same size.</li>
     *
     *        <li>Loop over the original array copying only differing values. Keep a record of the number of values
     *        copied.</li>
     *
     *        <li>Create a third array of limited size depending on the previous step's number of copies and
     *        fill in the desired values.</li>
     *    </ol>
     * </section>
     */
    public static int[] eliminate(final int[] input, int excludedValue) {
        if (null == input) {
            return new int[]{};
        } else {
            final int[] inputCopy = new int[input.length];
            int currentPosition = 0;
            for (final int i: input) {
                if (i != excludedValue) {
                    inputCopy[currentPosition++] = i;
                }
            }
            return Arrays.copyOfRange(inputCopy, 0, currentPosition);
        }
    }

    private _4_ArrayHelper(){/* Ignore me: Suppressing default constructor javadoc generation:
                                    javadoc does not include private constructors by default */}
}
