package de.hdm_stuttgart.mi.sd1.task1;

import java.util.Arrays;

public class _3_Range {

    /**
     *
     * <p>Turn a range defined by start and end value into a sorted array of values.</p>
     *
     * <p>A range of unique ascending values is being defined by a lower and upper inclusive limit. Examples:</p>
     *
     * <table class="goikTableDefaults">
     *     <tbody>
     *         <tr>
     *             <th>[rangeStartInclusive, rangeEndInclusive]</th>
     *             <th>Result array</th>
     *             <th>Remark</th>
     *         </tr>
     *         <tr>
     *             <td>[2, 7]</td>
     *             <td>{2, 3, 4, 5, 6, 7}</td>
     *             <td>All values in between 2 and 7</td>
     *         </tr>
     *         <tr>
     *             <td>[-5, -5]</td>
     *             <td>{-5}</td>
     *             <td>Just the single value -5</td>
     *         </tr>
     *         <tr>
     *             <td>[2, 1]</td>
     *             <td>{}</td>
     *             <td>Range end definition <code>1</code> is smaller than range start <code>2</code> ⇒ empty result.</td>
     *         </tr>
     *
     *     </tbody>
     *
     * </table>
     *
     * @param rangeStartInclusive Start of range (inclusive).
     * @param rangeEndInclusive End of range (inclusive).
     * @return All values within <code>[rangeStartInclusive, rangeEndInclusive]</code>. If
     * <code>rangeEndInclusive &lt; rangeStartInclusive</code> the resulting array is empty.
     */
    static public int[] createRange(final int rangeStartInclusive, final int rangeEndInclusive) {
        return null; // TODO: Implement me correctly
    }

    /**
     * <p>An array by range definition restricted by an array of values to be excluded.</p>
     *
     * <p>This method generalizes {@link #createRange(int, int)} by excluding values being present
     * in an array. Examples:</p>
     *
     * <table class="goikTableDefaults">
     *     <tbody>
     *         <tr>
     *             <th>[rangeStartInclusive, rangeEndInclusive]</th>
     *             <th>Excluded Values</th>
     *             <th>Result array</th>
     *             <th>Explanation</th>
     *         </tr>
     *         <tr>
     *             <td>[2, 7]</td>
     *             <td>{1, 4, 6}</td>
     *             <td>{2, 3, 5, 7}</td>
     *             <td>\( \{2, 3, \color{red}{4}, 5, \color{red}{6}, 7\} \) by range excluding
     *             \( \{\color{red}{1}, \color{red}{4}, \color{red}{6}\} \Longrightarrow \{2, 3, 5, 7\}\)  </td>
     *         </tr>
     *         <tr>
     *             <td>[-1, 3]</td>
     *             <td>{-1, 1, 2, 3}</td>
     *             <td>{0}</td>
     *             <td>\( \{\color{red}{-1}, 0, \color{red}{1}, \color{red}{2}, \color{red}{3}\} \) by range excluding
     *             \( \{\color{red}{-1}, \color{red}{1}, \color{red}{2}, \color{red}{3} \} \)
     *             \(\Longrightarrow \{0\}\) </td>
     *         </tr>
     *         <tr>
     *             <td>[1, 3]</td>
     *             <td>\( \{2, 1, 3, 4 \} \)</td>
     *             <td>{}</td>
     *             <td>\( \{\color{red}{1}, \color{red}{2}, \color{red}{3}\} \) by range excluding
     *             \( \{ \color{red}{2}, \color{red}{1}, \color{red}{3}, \color{red}{4} \} \)
     *             \(\Longrightarrow \{\}\)  </td>
     *         </tr>
     *
     *     </tbody>
     *
     * </table>
     *
     * <p/>
     *
     * <section class="implementationHints">
     *    <h3 class="implementationHints">Implementation hints:</h3>
     *    <p>The class {@link Arrays} offers assistance i.e. for copying arrays.</p>
     *    </ol>
     * </section>
     *
     * @param rangeStartInclusive Values greater than or equal
     * @param rangeEndInclusive Start of range (inclusive).
     * @param excludedValues End of range (inclusive).
     * @return All values within <code>[rangeStartInclusive, rangeEndInclusive]</code> <em>not</em> being
     * present in the <code>excludedValues</code> array.
     */
    static public int[]
    createRangeWithExclusions(final int rangeStartInclusive, final int rangeEndInclusive, final int[] excludedValues) {
        return null; // TODO: Implement me correctly
    }

    private _3_Range(){/* Ignore me: Suppressing default constructor javadoc generation:
                                    javadoc does not include private constructors by default */}
}
